package com.ruoyi.system.service.project;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.project.BmProject;
import com.ruoyi.system.domain.project.BmProjectStatus;

import java.util.List;
import java.util.Map;


/**
 * 项目(添加线索)Service接口
 * 
 * @author bm
 * @date 2021-03-03
 */
public interface IBmProjectService 
{
    /**
     * 查询项目(添加线索)
     * 
     * @param id 项目(添加线索)ID
     * @return 项目(添加线索)
     */
    public BmProject selectBmProjectById(Long id);

    /**
     * 查询项目(添加线索)列表
     * 
     * @param bmProject 项目(添加线索)
     * @return 项目(添加线索)集合
     */
    public List<BmProject> selectBmProjectList(BmProject bmProject);

    /**
     * 新增项目(添加线索)
     * 
     * @param bmProject 项目(添加线索)
     * @return 结果
     */
    public AjaxResult insertBmProject(BmProject bmProject);

    /**
     * 修改项目(添加线索)
     * 
     * @param bmProject 项目(添加线索)
     * @return 结果
     */
    public int updateBmProject(BmProject bmProject);

    /**
     * 批量删除项目(添加线索)
     * 
     * @param ids 需要删除的项目(添加线索)ID
     * @return 结果
     */
    public int deleteBmProjectByIds(Long[] ids);

    /**
     * 删除项目(添加线索)信息
     * 
     * @param id 项目(添加线索)ID
     * @return 结果
     */
    public int deleteBmProjectById(Long id);

    /**
     * 审核项目状态
     * @param bmProjectStatus 审核请求对象
     * @return
     */
   public AjaxResult examine(BmProjectStatus bmProjectStatus);

    /**
     * 首页查询待审核列表
     * @param bmProject
     * @return
     */
   public List<BmProject> selectToBeReviewedList(BmProject bmProject);


    /**
     * 统计分析公共查询列表
     * @param ids
     * @return
     */
   public List<BmProject> selectStatisticsList(Long[] ids,Long deptId);

    /**
     * 统计分析-在谈线索-柱状图
     * @param year
     * @return
     */
   public Map<String,Object> selectProjectEharts(String year);

    /**
     * 统计分析-签约项目-柱状图
     * @param year
     * @return
     */
   public Map<String,Object> selectProjectContractEharts(String year);

    /**
     * 每周三下午14点给未添加线索信息的用户发送短信
     */
    void selectBmProjectInProjectStatus();

    /**
     * 首页-统计数字(只根据当前登录人的部门)
     * @param bmProject
     * @return
     */
    AjaxResult indexInfo(BmProject bmProject);

    /**
     *通过企查查,查询企业信息
     * @param searchKey
     * @return
     */
    AjaxResult qichachaSearch(String searchKey);
}
